private ["_input", "_pos" , "_SLref", "_GLref","_tASL", "_tide", "_water", "_land","_shore","_rad", "_inc", "_radcnt", "_dir", "_X", "_Z", "_dis"];
_input = _this select 0;
_rad = abs (_this select 1);
_dis = abs (_this select 2);
if (_dis < 1) then {_dis = 1};
if (_rad < 5) then {_rad = 5};
if (count _input == 1) then {_pos = [(getPos (_input select 0)) select 0, (getPos (_input select 0)) select 1]};
if (count _input > 1) then {_pos = [_input select 0, _input select 1]};
_X = _pos select 0;
_Y = _pos select 1;
_water = false;
_land = false;
_shore = false;
_SLref = "emptyDetector" camcreate [0,0,0];
_GLref = "logic" camcreate [0,0,0];
_SLref setPos [0,0];
_GLref setPos [0,0,0];
_tide = _GLref distance _SLref;
_inc = 0;
_radcnt = 0;
While {_radcnt <= _rad && ! _shore}
Do
{
	if (_radcnt > 0) then {_inc = 360 / ( (360 / Asin (_dis/_radcnt)) - ((360 / Asin (_dis/_radcnt)) % 1) )};
	_dir = 0;
	While {_dir < 360 && ! _shore}
	Do
	{
		_pos = [(_X + (_radcnt * Sin _dir)), (_Y + (_radcnt * Cos _dir))];
		_SLref setPos _pos;
		_GLref setPos [_pos select 0, _pos select 1, 0];
		_tASL = _GLref distance _SLref;
		if (abs (_tASL - _tide) < .01) then {_water = true} else {_land = true};
		if (_water && _land) then {_shore = true};
		if (_inc > 0) then {_dir = _dir + _inc} else {_dir = 360};
	};
	_radcnt = _radcnt + _dis;
};
deleteVehicle _SLref;
deleteVehicle _GLref;
_shore